// othello board by Yves Debilloez
// example file
                                  
// Sky
#include "colors.inc"
#include "skies.inc"
#declare SkySphere = sky_sphere { S_Cloud1 }

// table
#include "shapes.inc"
#declare Table =
union {
   intersection {
      plane { +y, 0 }
      plane { -y,  3 }
      sphere { <0, -5.5, 0>, 55 }
   }

   intersection {
      plane { y, -8 }
      object {
         Hyperboloid_Y
         scale <10, 20, 10>
         translate -20*y
      }
   }

   pigment {
      granite
      scale 6
   }
   finish {
      specular 1
      roughness 0.02
      reflection 0.5
   }
}

// scene                                  
light_source { <0,190,-25> rgb 1 }

camera { location <45,35,12> look_at <0,0,0> }

#declare t_board =
texture{
	pigment{rgb 1}
	finish { specular .2 }
}

/*
plane {
	y 0
	texture { t_board }
}
*/

// goban

#include "othello.inc"

// own settings

othello()

#macro blackstone(a,b)
object { b_stone translate board_coords(a+1,b+1) }
#end
#macro whitestone(a,b)
object { w_stone translate board_coords(a+1,b+1) }
#end

//#include "moves.inc"

whitestone(3,3)
blackstone(4,3)
blackstone(3,4)
whitestone(4,4)


object { Table }
sky_sphere { SkySphere }
