//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#ifdef _DEBUG
#include <iostream>
#include <fstream>
#endif

#include "GameClasses.h"
#include "GameUICollection.h"

//---------------------------------------------------------------------------

USERES("StrategicGames.res");
USE("StrategicGames.todo", ToDo);
USEFORM("src\UI\SelectGameUI.cpp", SelectGameForm);
USEFORM("src\UI\CheckersBoardUI.cpp", CheckersFrame); /* TFrame: File Type */
USEFORM("src\UI\Connect4BoardUI.cpp", Connect4BoardFrame); /* TFrame: File Type */
USEFORM("src\UI\DocumentationUI.cpp", DocumentationForm);
USEFORM("src\UI\EngineUI.cpp", FrameEngineUI); /* TFrame: File Type */
USEUNIT("src\UI\GameUICollection.cpp");
USEFORM("src\UI\HelpUI.cpp", HelpBox);
USEFORM("src\UI\ImExportUI.cpp", InExportDialog);
USEFORM("src\UI\MainUI.cpp", MainForm);
USEFORM("src\UI\OthelloBoardUI.cpp", OthelloBoardFrame); /* TFrame: File Type */
USEFORM("src\UI\SelectCheckersUI.cpp", SelectCheckersUIForm);
USEFORM("src\UI\AboutUI.cpp", AboutBox);
USEUNIT("src\EngOthelloLev3.cpp");
USEUNIT("src\CheckersEngLev1.cpp");
USEUNIT("src\EngConnect4.cpp");
USEUNIT("src\EngConnect4Lev1.cpp");
USEUNIT("src\EngOthello.cpp");
USEUNIT("src\EngOthelloLev2.cpp");
USEUNIT("src\EngGame.cpp");
USEUNIT("src\algo\AlgorithmBase.cpp");
USEUNIT("src\algo\AlgorithmBruteForce.cpp");
USEUNIT("src\algo\AlgorithmNegascout.cpp");
USEUNIT("src\algo\AlgorithmAlphaBeta.cpp");
USEFORM("src\UI\BoardDraughtsUI.cpp", DraughtsFrame); /* TFrame: File Type */
USEUNIT("src\EngDraughts.cpp");
USEFORM("src\UI\BoardTicTacToeUI.cpp", TicTacToeFrame); /* TFrame: File Type */
USEUNIT("src\EngTicTacToe.cpp");
USEUNIT("src\algo\AlgorithmBruteFWin.cpp");
USEUNIT("src\algo\AlgorithmStaticEval.cpp");
USEUNIT("src\GameClasses.cpp");
USEUNIT("src\EngCheckersBase.cpp");
USEUNIT("src\CheckersEng.cpp");
//---------------------------------------------------------------------------
GameUIData *mGameUI;
TGame      *mGameData;

//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{

  try
  {
    #ifdef _DEBUG
    // start redirection
    std::ofstream log_tmp("StrategicGames.log");
    std::streambuf *clog_buf = std::clog.rdbuf();
    std::clog.rdbuf(log_tmp.rdbuf());
    #endif

    Application->Initialize();
    mGameUI = (GameUIData*) new OthelloUIData();
    mGameData = (TGame*) new TGame();
    Application->Title = "Strategic Games";
    Application->CreateForm(__classid(TMainForm), &MainForm);
    Application->CreateForm(__classid(TSelectGameForm), &SelectGameForm);
    Application->CreateForm(__classid(TDocumentationForm), &DocumentationForm);
    Application->CreateForm(__classid(THelpBox), &HelpBox);
    Application->CreateForm(__classid(TInExportDialog), &InExportDialog);
    Application->CreateForm(__classid(TSelectCheckersUIForm), &SelectCheckersUIForm);
    Application->CreateForm(__classid(TAboutBox), &AboutBox);
    Application->Run();

    #ifdef _DEBUG
    // stop redirection
    std::clog.flush();
    std::clog.rdbuf(clog_buf);
    #endif
  }
  catch (Exception &exception)
  {
     Application->ShowException(&exception);
  }

  return 0;
}
//---------------------------------------------------------------------------
