//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BoardPiece.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TBoardPiece *)
{
  new TBoardPiece(NULL);
}

//---------------------------------------------------------------------------

__fastcall TBoardPiece::TBoardPiece(TComponent* Owner)
  : TImage(Owner)
{
  for (int i=0;i<NUM_BITMAPS;i++)
    pBitmap[i] = new Graphics::TBitmap();
  iActivePicture = -1;
}

//---------------------------------------------------------------------------
// destructor to delete resources

__fastcall TBoardPiece::~TBoardPiece()
{
  for (int i=0;i<NUM_BITMAPS;i++)
    delete pBitmap[i];
}

//---------------------------------------------------------------------------

namespace Boardpiece
{
  void __fastcall PACKAGE Register()
  {
    TComponentClass classes[1] = {__classid(TBoardPiece)};
    RegisterComponents("YD", classes, 0);
  }
}

//---------------------------------------------------------------------------
// store the picture in the object for later use
// use it through activatepicture

bool TBoardPiece::SetPicture(int nIndex, Graphics::TBitmap * pPassedBitmap)
{
  if ((nIndex>=0) && (nIndex<NUM_BITMAPS))
  {
    pBitmap[nIndex]->Assign(pPassedBitmap);
    return true;
  }

  return false;
}

//---------------------------------------------------------------------------
// select a new active picture

void TBoardPiece::ActivatePicture(const int nIndex)
{
  iActivePicture = nIndex;

  if ((iActivePicture>=0) && (iActivePicture < NUM_BITMAPS))
    Picture->Assign(pBitmap[iActivePicture]);
  else
    Picture->Assign(NULL);
}

//---------------------------------------------------------------------------
// return the current active bitmap

int TBoardPiece::GetPictureID()
{
  return iActivePicture;
}

//---------------------------------------------------------------------------
// eof



