//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "CheckersEngLev1.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall Unit1::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall CheckersEngLev1::CheckersEngLev1(TAlgorithmType nType)
  : CheckersEngine(nType)
{
}

// ---------------------------------------------------------------------------
// calculate the value of the position

#define SC_P0         16
#define SC_P1 SC_P0   + 1
#define SC_P2 SC_P0   + 2
#define SC_P3 SC_P0   + 3

signed long int CheckersEngLev1::EvaluatePos(const int nColour)
{
  int i,j;

  signed long int liValue = 0;
  signed long int aValues[] = { 0 , 1 , -1 , 0 , 0 , 2 , -2 };
  static signed int aBoardScores[8][8] = {
   { SC_P0 , SC_P1 , SC_P2 , SC_P1 , SC_P1 , SC_P2 , SC_P1 , SC_P0 } ,
   { SC_P0 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P0 } ,
   { SC_P0 , SC_P2 , SC_P3 , SC_P3 , SC_P3 , SC_P3 , SC_P2 , SC_P0 } ,
   { SC_P0 , SC_P2 , SC_P3 , SC_P3 , SC_P3 , SC_P3 , SC_P2 , SC_P0 } ,
   { SC_P0 , SC_P2 , SC_P3 , SC_P3 , SC_P3 , SC_P3 , SC_P2 , SC_P0 } ,
   { SC_P0 , SC_P2 , SC_P3 , SC_P3 , SC_P3 , SC_P3 , SC_P2 , SC_P0 } ,
   { SC_P0 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P1 , SC_P0 } ,
   { SC_P0 , SC_P1 , SC_P2 , SC_P1 , SC_P1 , SC_P2 , SC_P1 , SC_P0 } };

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      if (aBoard[i][j])
        liValue += (aValues[aBoard[i][j]]*aBoardScores[i][j]);

  return nColour==1?liValue:-liValue;
}

// ---------------------------------------------------------------------------
// eof

