//---------------------------------------------------------------------------

#ifndef EngCheckersBaseH
#define EngCheckersBaseH
//---------------------------------------------------------------------------
#include <Classes.hpp>

#include "GameClasses.h"
#include "EngGame.h"
#include "AlgorithmBase.h"

#define ALL_MOVE_TYPES 1
#define CAPTURES_ONLY 0

//---------------------------------------------------------------------------
class EngCheckersBase: public GameEngine
{
private:
  int          GenerateMovesType(TMoveList *aMoves,const int nPiece,
                const int nStartingPos,int nMode);
  virtual bool AddValidFrom(const int nPos, const int nOwnColour, TMoveList *aMoves,
                const int nMode)=0;
protected:
  bool         IsValidFrom(int nPos,int nOwnColour);
  bool         IsEnded(const int nColour,int *nScoreEnded);
  int          GenerateMoves(TMoveList *aMoves,const int nPiece);
  void         AddValidMoveToList(TMoveList *aMoves, const int nFrom,
                const int nTo, const bool bCaptureMove);
  bool         ApplyNextMove(TSingleMove *nMove,const int nPiece);
  virtual void InitBoard(void);
public:
   __fastcall  EngCheckersBase(TAlgorithmType nType);
  virtual bool ApplyMove(TSingleMove nMove,const int nPiece,
                const int nMoveType);
  int          MoveRepresentation(TSingleMove *nMove, char *sMove);
  void         Str2Move(char *sMove,TSingleMove *nMove);
  virtual signed long int EvaluatePos(const int nColour)=0;
__published:
};

//---------------------------------------------------------------------------
#endif
