//---------------------------------------------------------------------------

#ifndef EngConnect4H
#define EngConnect4H
//---------------------------------------------------------------------------
#include <Classes.hpp>

#include "GameClasses.h"
#include "EngGame.h"
#include "AlgorithmBase.h"

//---------------------------------------------------------------------------
class Connect4Eng : public GameEngine
{
private:
  bool CanPlayAt(int nPos,int nOwnColour);
  virtual signed long int EvaluateCase(const int nX,const int nY,
      const int nColour);
  void MakeMask(int nX,int nY,const int ndX,const int ndY,int aMask[7]);
  int EvaluateMask(int aMask[4][7],int nColour);
protected:
  int GenerateMoves(TMoveList *aMoves,int nColour);
public:
   __fastcall Connect4Eng(TAlgorithmType nType);
  bool ApplyMove(const TSingleMove nPos,const int nColour,
      const int nMoveType);
  bool IsEnded(const int nColour,int *nScoreEnded);
  virtual signed long int EvaluatePos(const int nColour);
  int MoveRepresentation(TSingleMove *nMove, char *sMove);  
  void Str2Move(char *sMove,TSingleMove *nMove);
__published:
};
//---------------------------------------------------------------------------
#endif
