//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "EngOthelloLev2.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall Unit1::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall OthelloEngineLev2::OthelloEngineLev2(TAlgorithmType nType)
  : OthelloEngine(nType)
{
}

// ---------------------------------------------------------------------------
// calculate the value of the position

#define SC_P0 4
#define SC_P1 SC_P0 + 2
#define SC_P2 SC_P0 + 4
#define SC_P3 SC_P0 + 8
#define SC_P4 SC_P0 + 16
#define SC_P5 SC_P0 + 96

signed long int OthelloEngineLev2::EvaluatePos(const int nColour)
{
  int i,j;

  signed long int liValue = 0;
  signed long int aValues[] = { 0 , 1 , -1 };
  static signed int aBoardScores[8][8] = {
   { SC_P5 , SC_P0 , SC_P4 , SC_P3 , SC_P3 , SC_P4 , SC_P0 , SC_P5 } ,
   { SC_P0 , SC_P0 , SC_P1 , SC_P2 , SC_P2 , SC_P1 , SC_P0 , SC_P0 } ,
   { SC_P4 , SC_P1 , SC_P4 , SC_P2 , SC_P2 , SC_P4 , SC_P1 , SC_P4 } ,
   { SC_P3 , SC_P2 , SC_P2 , SC_P1 , SC_P1 , SC_P2 , SC_P2 , SC_P3 } ,
   { SC_P3 , SC_P2 , SC_P2 , SC_P1 , SC_P1 , SC_P2 , SC_P2 , SC_P3 } ,
   { SC_P4 , SC_P1 , SC_P4 , SC_P2 , SC_P2 , SC_P4 , SC_P1 , SC_P4 } ,
   { SC_P0 , SC_P1 , SC_P1 , SC_P2 , SC_P2 , SC_P1 , SC_P0 , SC_P0 } ,
   { SC_P5 , SC_P0 , SC_P4 , SC_P3 , SC_P3 , SC_P4 , SC_P0 , SC_P5 } };

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      if (aBoard[i][j])
        liValue += (aValues[aBoard[i][j]]*aBoardScores[i][j]);

  return nColour==1?liValue:-liValue;
}

// eof



