#include "GameClasses.h"

//---------------------------------------------------------------------------

const TSingleMove& TSingleMove::operator= (const TSingleMove& rsp)
{
  // if not the same object
  if ( this != &rsp)
  {
    this->MoveTo       = rsp.MoveTo;
    this->MoveFrom     = rsp.MoveFrom;
    this->nScore       = rsp.nScore;
    this->nNextMove    = rsp.nNextMove;
    this->bCaptureMove = rsp.bCaptureMove;
    this->bValidMove   = rsp.bValidMove;
  }

  // by C++ convention, return pointer to this
  return *this;
}

//---------------------------------------------------------------------------
// no comparison of flags, allows for
// alignment in the user interface

bool TSingleMove::operator==(const TSingleMove& rsp)
{
  return (this->MoveTo    == rsp.MoveTo  ) &&
         (this->MoveFrom  == rsp.MoveFrom) &&
         (this->nNextMove == rsp.nNextMove);
}
//---------------------------------------------------------------------------
/*
bool TSingleMove::operator==(unsigned TSingleMove lsp, const TSingleMove rsp)
{
  if (&lsp == &rsp) return true;
  return false;
}
*/
//---------------------------------------------------------------------------
// we only declare the score, the other fields can remain
// undeclared, movelist is managing its moves

TSingleMove::TSingleMove(void)
{
  init();
}

//---------------------------------------------------------------------------
// init move to invalid move

inline void TSingleMove::init(void)
{
  this->nScore        = -SCORE_INFINITE;
  this->bCaptureMove  = false;
  this->bValidMove    = false;
  this->nNextMove     = -1;
  this->MoveFrom      = -1;
  this->MoveTo        = -1;
}

//---------------------------------------------------------------------------
TSingleMove::TSingleMove(const TSingleMove& rsp)
{
  this->MoveTo        = rsp.MoveTo;
  this->MoveFrom      = rsp.MoveFrom;
  this->nScore        = rsp.nScore;
  this->bCaptureMove  = rsp.bCaptureMove;
  this->bValidMove    = rsp.bValidMove;
  this->nNextMove     = rsp.nNextMove;
}

//---------------------------------------------------------------------------

/*
const TBoard& TBoard::operator= (const TBoard& rsp)
{
  // if not the same object
  if ( this != &rsp)
  {
    register int i,j;

    for (i=0;i<MAX_BOARD_DIMENSION;i++)
      for (j=0;j<MAX_BOARD_DIMENSION;j++)
        this->aBoard[i][j] = rsp.aBoard[i][j];
  }

  // by C++ convention, return pointer to this
  return *this;
}
*/

//---------------------------------------------------------------------------

TGame::TGame(void)
{
  init();
}

//---------------------------------------------------------------------------
// init method so that data can be refreshed without destroying
// the object and recreating

void TGame::init(void)
{
  nGameStatus     = GAMESTATUS_INIT;
  nToMove         = 1;
  nComputerColour = 2;
}

//---------------------------------------------------------------------------
// eof


