#ifndef GameClassesH
#define GameClassesH

//---------------------------------------------------------------------------

#define SCORE_INFINITE        9999  // no valid value
#define SCORE_ISWON           9000  // winning score
#define SCORE_ISWONPAR        8000  // large enough difference to consider win
#define SCORE_DRAW            0     // draw game

#define MAX_BOARD_DIMENSION   10     // largest board possible
#define MAX_MOVES_IN_HISTORY  250

enum GAMESTATUS {GAMESTATUS_INIT,
                 GAMESTATUS_PLAYING,
                 GAMESTATUS_ENDED };

#define MAXUNIQUEMOVES 64 // the maximum number of valid moves
                          // in a certain position for any game

//---------------------------------------------------------------------------
// TODO: comparison operator, invalidate function
// TODO: research why the copy constructor is called in some cases

class TSingleMove
{
private:
protected:
public:
  // default constructor
  TSingleMove(void);
  TSingleMove(const TSingleMove &rsp);

  // initialisation method
  void init(void);

  long MoveFrom;
  long MoveTo;
  int nScore;
  int nNextMove;
  bool bCaptureMove;
  bool bValidMove;

  const TSingleMove& operator=(const TSingleMove& rsp);
  bool operator==(const TSingleMove& rsp);
  //bool operator==(unsigned TSingleMove lsp, const TSingleMove rsp);
};

//---------------------------------------------------------------------------

class TMoveList
{
private:
protected:
public:
  int TotalMoves;
  TSingleMove aMoves[MAXUNIQUEMOVES];
};

//---------------------------------------------------------------------------

class TBoard
{
private:
protected:
public:
  //const TBoard& operator=(const TBoard& rsp);
  int aBoard[MAX_BOARD_DIMENSION][MAX_BOARD_DIMENSION];
};

//---------------------------------------------------------------------------

class TGame
{
private:
protected:
public:
  TGame(void);
  void init(void);
  GAMESTATUS nGameStatus;
  int nComputerColour;
  int nToMove;
};

//---------------------------------------------------------------------------

#endif




