//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <Registry.hpp>

#include "AboutUI.h"

#define PERIOD_FORCHECK 30.0
#define VERSION_STRING "12"
#define REGKEY_LOCATION "Software\\YD\\Strategic Games\\"

//---------------------------------------------------------------------
#pragma resource "*.dfm"
TAboutBox *AboutBox;
//---------------------------------------------------------------------
__fastcall TAboutBox::TAboutBox(TComponent* AOwner)
	: TForm(AOwner)
{
  bool bNeedsUpdate = false;

  TDateTime tDateCheck;
  TDateTime tNow = TDateTime::CurrentDateTime();
  TRegistry *Registry = new TRegistry;

  String sPath = ExtractFilePath(ParamStr(0));

  AboutMemo->Lines->LoadFromFile(sPath+"file_id.diz");
  AboutImage->Picture->LoadFromFile(sPath+"IMAGES\\SG1.jpg");

  Caption = "About " + Application->Title;

  // check if we need to verify for an update
  // will show the label blinking
  try
  {
    Registry->RootKey = HKEY_LOCAL_MACHINE;
    Registry->OpenKey(REGKEY_LOCATION,false);
    if (Registry->ValueExists("LastUpdateCheck"))
    {
      tDateCheck = Registry->ReadDateTime("LastUpdateCheck");
      if (((double)tNow - (double)tDateCheck)>PERIOD_FORCHECK) bNeedsUpdate = true;
    }
  }
  __finally
  {
    delete Registry;
    bNeedsUpdate = true;
  }

  if (bNeedsUpdate)
  {
    // we assume that an update of the software needs to
    // be checked after first install or when never checked and
    // after 30 days
    CheckUpdatesText->Visible = true;
  }
}

//---------------------------------------------------------------------

void __fastcall TAboutBox::OKButtonClick(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------

void __fastcall TAboutBox::HomePageTextClick(TObject *Sender)
{
  // todo: Include the version number so statistics can be obtained per version
  ShellExecute(Handle,"open","http://users.pandora.be/ai",
              NULL,NULL,SW_SHOWMAXIMIZED);
}

//---------------------------------------------------------------------------

bool __fastcall TAboutBox::FormHelp(WORD Command, int Data, bool &CallHelp)
{
   // ShowMessage("OnHelp");
   return false;
}

//---------------------------------------------------------------------------

void __fastcall TAboutBox::CheckUpdatesTextClick(TObject *Sender)
{
  // todo: Include the version number so statistics can be obtained per version
  ShellExecute(Handle,"open","http://users.pandora.be/ai/doc/"
                      "sg" VERSION_STRING "/index.html",
              NULL,NULL,SW_SHOWMAXIMIZED);

  TDateTime tNow = TDateTime::CurrentDateTime();
  TRegistry *Registry = new TRegistry;

  try
  {
    Registry->RootKey = HKEY_LOCAL_MACHINE;
    Registry->OpenKey(REGKEY_LOCATION,true);
    Registry->WriteDateTime("LastUpdateCheck",tNow);
    CheckUpdatesText->Visible = false;
  }
  __finally
  {
    delete Registry;
  }

}

//---------------------------------------------------------------------------

