//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainUI.h"
#include "BoardTicTacToeUI.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BoardPiece"
#pragma resource "*.dfm"
TTicTacToeFrame *TicTacToeFrame;
//---------------------------------------------------------------------------
__fastcall TTicTacToeFrame::TTicTacToeFrame(TComponent* Owner)
  : TFrame(Owner)
{
  int i;
  String sPath = ExtractFilePath(ParamStr(0));

  for (i=0;i<NUM_TICTACTOESTONES;i++)
    pPiece[i] = new Graphics::TBitmap;

  pPiece[0]->LoadFromFile(sPath+"Images\\TicTacToe_WhiteStone.bmp");
  pPiece[1]->LoadFromFile(sPath+"Images\\TicTacToe_BlackStone.bmp");

  // make sure no single non playable field does contain a tag
  // value that is used for finding pieces
  for (i=0;i<TicTacToePanel->ControlCount;i++)
  {
    if (dynamic_cast <TBoardPiece*> (TicTacToePanel->Controls[i]))
    {
      ((TBoardPiece*)TicTacToePanel->Controls[i])->SetPicture(0,pPiece[0]);
      ((TBoardPiece*)TicTacToePanel->Controls[i])->SetPicture(1,pPiece[1]);
    }
  }

  nSelected = -1;

#ifdef _DEBUG
  // update the hints display so we can esily debug
  // we might need to remove this setting for final version
  for (i=0;i<TicTacToePanel->ControlCount;i++)
    if (dynamic_cast <TBoardPiece*> (TicTacToePanel->Controls[i]))
      ((TBoardPiece*)TicTacToePanel->Controls[i])->Hint =
        ((TBoardPiece*)TicTacToePanel->Controls[i])->Tag;
#endif
}

//---------------------------------------------------------------------------

int TTicTacToeFrame::GetControlCount(void)
{
  return TicTacToePanel->ControlCount;
}

//---------------------------------------------------------------------------

int TTicTacToeFrame::GetObjectValue(int nIndex)
{
  return TicTacToePanel->Controls[nIndex]->Tag;
}

//---------------------------------------------------------------------------

void TTicTacToeFrame::SetPieceAt(int nPos, int nColour)
{
  int i, nMax;
  int aMapper [] = { 4 , 0 , 1 };
  int iPicture = aMapper[nColour];

  nMax = TicTacToePanel->ControlCount;

  for (i=0;i<nMax;i++)
  {
    if (dynamic_cast <TBoardPiece*> (TicTacToePanel->Controls[i]))
    {
      if (nPos == GetObjectValue(i))
      {
        if (((TBoardPiece*)(TicTacToePanel->Controls[i]))->GetPictureID() !=
            iPicture)
          ((TBoardPiece*)(TicTacToePanel->Controls[i]))->ActivatePicture(iPicture);
        return;
      }
    }
  }
}

//---------------------------------------------------------------------------
// clear all selected moves on the board

void TTicTacToeFrame::ClearSelects(void)
{
  int i;

  for (i=0;i<ControlCount;i++)
    if (dynamic_cast <TBoardPiece*> (Controls[i]))
      if (!((TBoardPiece*)Controls[i])->Transparent)
        // this test avoids flickering by only updating when there is something
        // to update
        ((TBoardPiece*)Controls[i])->Transparent = true;

  nSelected = -1;
}

//---------------------------------------------------------------------------

void __fastcall TTicTacToeFrame::BoardPieceClick(TObject *Sender)
{
  TSingleMove nMove;

  nMove.MoveFrom = 0;
  nMove.MoveTo = ((TBoardPiece*)Sender)->Tag;

  if (MainForm->IsValidMove(nMove))
  {
    ClearSelects();
    MainForm->PlayValidMove(nMove);
  }
}
//---------------------------------------------------------------------------
// eof

