//---------------------------------------------------------------------------

#ifndef EngineUIH
#define EngineUIH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <AppEvnts.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <ComCtrls.hpp>

#include "EngOthello.h"
#include "EngCheckersBase.h"

//---------------------------------------------------------------------------
class TFrameEngineUI : public TFrame
{
__published:	// IDE-managed Components
  TLabel *Label2;
  TLabel *LabelValue;
  TAnimate *AnimateComputerCalc;
  TLabel *Label3;
  TLabel *LabelTime;
  TComboBox *ComboBoxLevel;
  TMemo *DetailsMemo;
  TComboBox *AlgorithmComboBox;
  TBitBtn *PassBitBtn;
  TLabel *Label1;
  TCheckBox *ExperimentalCheckBox;
  void __fastcall ButtonPassClick(TObject *Sender);
  void __fastcall ComboBoxLevelChange(TObject *Sender);
  void __fastcall AlgorithmComboBoxChange(TObject *Sender);
  void __fastcall ExperimentalCheckBoxClick(TObject *Sender);
private:   // User declarations
  void DumpEngine(void);
  void CreateEngine(void);
  bool CalcMove(void);
  bool UpdateDisplay(void);
  void ExperimentalSearch(void);
public:		// User declarations
  GameEngine *oEngine;
  __fastcall TFrameEngineUI(TComponent* Owner);
  void _fastcall NewGame(void);
  void PlayValidMove(TSingleMove nMove);
  int GetStoneAt(int nPos);
  void SaveGame(AnsiString sFileName);
  void OpenGame(AnsiString sFileName);
  bool SwitchUser();
  bool IsValidMove(TSingleMove &nMove);
  bool IsValidFrom(int nPos,int nColour);
  bool ResetDisAllowed();
  __fastcall ~TFrameEngineUI();
//  bool PlayMove(TSingleMove nMove);
protected:
};
//---------------------------------------------------------------------------
extern PACKAGE TFrameEngineUI *FrameEngineUI;
//---------------------------------------------------------------------------
#endif
