//---------------------------------------------------------------------------

#ifndef GameUICollectionH
#define GameUICollectionH
//---------------------------------------------------------------------------
#include <vcl\vcl.h>

//---------------------------------------------------------------------------

enum GAMETYPE {GAMETYPE_OTHELLO,GAMETYPE_CHECKERS_AMERICAN,
               GAMETYPE_CHECKERS_SIMPLE,GAMETYPE_CONNECT4,
               GAMETYPE_DRAUGHTS,GAMETYPE_TICTACTOE};

//---------------------------------------------------------------------------

class GameUIData
{
private:
protected:
public:
  TColor      mColourWhite;
  TColor      mColourBlack;
  TColor      mColourEmpty;
  TColor      mColourSelectFrom;
  TColor      mColourSelectTo;
  TColor      mColourSelectNone;
  TShapeType  mPieceShape;
  char        sName[256];
  char        sWhiteName[256];
  char        sBlackName[256];
  GAMETYPE    mGameType;
};

//---------------------------------------------------------------------------

class OthelloUIData : GameUIData
{
private:
protected:
public:
  OthelloUIData(void);
};

//---------------------------------------------------------------------------

class Connect4UIData : GameUIData
{
private:
protected:
public:
  Connect4UIData(void);
};

//---------------------------------------------------------------------------
class CheckersUIData : GameUIData
{
private:
protected:
public:
  CheckersUIData(void);
};

//---------------------------------------------------------------------------
class DraughtsUIData : GameUIData
{
private:
protected:
public:
  DraughtsUIData(void);
};

//---------------------------------------------------------------------------
class TicTacToeUIData : GameUIData
{
private:
protected:
public:
  TicTacToeUIData(void);
};

//---------------------------------------------------------------------------
#endif
