//---------------------------------------------------------------------------
#ifndef MainUIH
#define MainUIH
//---------------------------------------------------------------------------
#include <vcl\sysutils.hpp>
#include <vcl\windows.hpp>
#include <vcl\messages.hpp>
#include <vcl\sysutils.hpp>
#include <vcl\classes.hpp>
#include <vcl\graphics.hpp>
#include <vcl\controls.hpp>
#include <vcl\forms.hpp>
#include <vcl\dialogs.hpp>
#include <vcl\stdctrls.hpp>
#include <vcl\buttons.hpp>
#include <vcl\extctrls.hpp>
#include <vcl\menus.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "CheckersBoardUI.h"
#include "Connect4BoardUI.h"
#include "EngineUI.h"
#include "OthelloBoardUI.h"
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include "EngineUI.h"
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include "CheckersBoardUI.h"
#include "OthelloBoardUI.h"
#include "GameUICollection.h"
#include "Connect4BoardUI.h"
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "BoardPiece.h"
#include <Graphics.hpp>
#include "BoardDraughtsUI.h"
#include "BoardTicTacToeUI.h"

#if !defined(_DEBUG)
//#define _MULTI_THREADED_
#endif

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
  TStatusBar *StatusLine;
  TShape *ToMoveShape;
  TLabel *Label2;
  TFrameEngineUI *FrameEngineUI;
  TOthelloBoardFrame *OthelloBoardFrame;
  TCheckersFrame *CheckersBoardFrame;
  TConnect4BoardFrame *Connect4BoardFrame;
  TImageList *MenuImages;
  TActionList *MainFormActions;
  TAction *NewGameAction;
  TAction *NewSameAction;
  TAction *ExitAction;
  TMainMenu *MainMenu;
  TMenuItem *FileMenu;
  TMenuItem *FileNewItem;
  TMenuItem *FileSaveItem;
  TMenuItem *N4;
  TMenuItem *FileExitItem;
  TMenuItem *HelpMenu;
  TMenuItem *HelpContentsItem;
  TMenuItem *HelpRulesItem;
  TMenuItem *N5;
  TMenuItem *HelpAboutItem;
  TToolBar *IconToolBar;
  TToolButton *NewGameButton;
  TToolButton *NewSameToolButton;
  TToolButton *ToolButton1;
  TToolButton *ExitToolButton;
  TToolButton *ToolButton2;
  TToolButton *ToolButton3;
  TToolButton *ToolButton4;
  TToolButton *ToolButton5;
  TBoardPiece *ToMoveBoardPiece;
  TAction *AboutAction;
  TAction *RulesAction;
  TAction *HelpAction;
  TAction *SaveAction;
  TToolButton *ToolButton6;
  TMenuItem *FileOpenItem;
  TAction *OpenAction;
  TToolButton *ToolButton7;
  TPopupMenu *PopupMenu;
  TMenuItem *New1;
  TMenuItem *Exit1;
  TMenuItem *Save1;
  TMenuItem *Exit2;
  TMenuItem *New2;
  TMenuItem *Othello1;
  TMenuItem *AmericanCheckers1;
  TMenuItem *Simplecheckers1;
  TMenuItem *Connect41;
  TMenuItem *N1;
  TMenuItem *Restartgame2;
  TAction *NewOthelloAction;
  TAction *NewACheckersAction;
  TAction *NewConnect4Action;
  TAction *NewSCheckersAction;
  TMenuItem *NewAmericanCheckersgame1;
  TMenuItem *NewAmericanCheckersgame2;
  TMenuItem *NewSimpleCheckersgame1;
  TMenuItem *NewConnect4game1;
  TMenuItem *Restartgame1;
  TToolButton *ToolButton8;
  TToolButton *ToolButton9;
  TToolButton *ToolButton10;
  TToolButton *ToolButton11;
  TToolButton *ToolButton12;
  TMenuItem *Edit1;
  TAction *ComputerStartsAction;
  TMenuItem *Computerstarts1;
  TDraughtsFrame *DraughtsFrame;
  TAction *NewDraughtsAction;
  TToolButton *ToolButton13;
  TMenuItem *NewDraughtsGame1;
  TMenuItem *NewDraughtsGame2;
  TTicTacToeFrame *TicTacToeFrame;
  TAction *NewTicTacToeAction;
  TToolButton *ToolButton14;
  TMenuItem *NewTicTacToeGame1;
  TMenuItem *NewTicTacToeGame2;  // &Contents
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall ShowHint(TObject *Sender);
  void __fastcall FileNew(TObject *Sender);
  void __fastcall FileSave(TObject *Sender);
  void __fastcall FileExit(TObject *Sender);
  void __fastcall HelpAbout(TObject *Sender);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall HelpRulesItemClick(TObject *Sender);
  void __fastcall NewSameButtonClick(TObject *Sender);
  void __fastcall DocumentationItemClick(TObject *Sender);
  void __fastcall FrameEngineUIComboBoxLevelChange(TObject *Sender);
  void __fastcall OpenActionExecute(TObject *Sender);
  void __fastcall NewACheckersActionExecute(TObject *Sender);
  void __fastcall NewOthelloActionExecute(TObject *Sender);
  void __fastcall NewConnect4ActionExecute(TObject *Sender);
  void __fastcall NewSCheckersActionExecute(TObject *Sender);
  void __fastcall ComputerStartsActionExecute(TObject *Sender);
  void __fastcall NewDraughtsActionExecute(TObject *Sender);
  void __fastcall NewTicTacToeActionExecute(TObject *Sender);
private:        // private user declarations
  bool bFirstRun;
  Graphics::TBitmap *pPiece[2];
  bool StartAGame();
  void StartGivenGameUI();
  void StartGivenGame();
public:         // public user declarations
  virtual __fastcall TMainForm(TComponent* Owner);
//  void SetStone(int nPos, int nColour);
  void UpdateBoard(void);
  void UpdateDisplay(void);
  int GetBoardPositions(void);
  int GetObjectValue(int nPos);
  bool IsValidMove(TSingleMove nMove);
  bool IsValidFrom(int nPos);
  void PlayValidMove(TSingleMove nMove);
  __fastcall ~TMainForm();
protected:
  void UISetPieceAt(int nPos, int nColour);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif

