//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SelectGameUI.h"
#include "SelectCheckersUI.h"
#include "DocumentationUI.h"
#include "GameUICollection.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSelectGameForm *SelectGameForm;

//---------------------------------------------------------------------------

__fastcall TSelectGameForm::TSelectGameForm(TComponent* Owner)
  : TForm(Owner)
{
  // default selection
  mSelectedGame = GAMETYPE_OTHELLO;

  String sPath = ExtractFilePath(ParamStr(0));
  GameImage->Picture->LoadFromFile(sPath+"IMAGES\\" "othello.jpg");
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::OKButtonClick(TObject *Sender)
{
  if (CheckersRadioButton->Checked)
    CheckersRadioButtonDblClick(Sender);
  else
    StoreSelectedGame();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::CancelButtonClick(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::OthelloRadioButtonDblClick(
      TObject *Sender)
{
  StoreSelectedGame();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::Connect4RadioButtonDblClick(
      TObject *Sender)
{
  StoreSelectedGame();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::TicTacToeRadioButtonDblClick(
      TObject *Sender)
{
  StoreSelectedGame();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::CheckersRadioButtonDblClick(
      TObject *Sender)
{
  SelectCheckersUIForm->ShowModal();
  if (SelectCheckersUIForm->mSelectedGame != -1)
    StoreSelectedGame();
}

//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::RulesButtonClick(TObject *Sender)
{
  DocumentationForm->IE->Navigate(WideString(ExtractFilePath(ParamStr(0))+"rules.html"));
  DocumentationForm->ShowModal();
}

//---------------------------------------------------------------------------
// before closing, set the right variables
// here we will interprete the user interface object to know
// what game has been selected

void TSelectGameForm::StoreSelectedGame()
{
  if (OthelloRadioButton->Checked)
    mSelectedGame = GAMETYPE_OTHELLO;
  else if (Connect4RadioButton->Checked)
    mSelectedGame = GAMETYPE_CONNECT4;
  else if (TicTacToeRadioButton->Checked)
    mSelectedGame = GAMETYPE_TICTACTOE;
  else
    mSelectedGame = SelectCheckersUIForm->mSelectedGame;

  Close();
}

//---------------------------------------------------------------------------
void __fastcall TSelectGameForm::OthelloRadioButtonEnter(TObject *Sender)
{
  // select othello
  String sPath = ExtractFilePath(ParamStr(0));
  GameImage->Picture->LoadFromFile(sPath+"IMAGES\\" "othello.jpg");
}
//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::CheckersRadioButtonEnter(TObject *Sender)
{
  // select checkers
  String sPath = ExtractFilePath(ParamStr(0));
  GameImage->Picture->LoadFromFile(sPath+"IMAGES\\" "checkers.jpg");
}
//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::Connect4RadioButtonEnter(TObject *Sender)
{
  // connect 4
  String sPath = ExtractFilePath(ParamStr(0));
  GameImage->Picture->LoadFromFile(sPath+"IMAGES\\" "connect4.jpg");
}
//---------------------------------------------------------------------------

void __fastcall TSelectGameForm::TicTacToeRadioButtonEnter(TObject *Sender)
{
  // tictactoe
  String sPath = ExtractFilePath(ParamStr(0));
  GameImage->Picture->LoadFromFile(sPath+"IMAGES\\" "tictactoe.jpg");
}

//---------------------------------------------------------------------------
// eof



