//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#ifdef _DEBUG
#include <iostream>
#include <fstream>
#endif

#include "AlgorithmBase.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
// constructor of base class, no use except for avoiding a virutal
// constructor

Algorithm::Algorithm(void)
{
  sName->assign("Virtual");
}

//---------------------------------------------------------------------------
// log all moves played till here in the movelist

#ifdef _DEBUG
  void Algorithm::LogMoveList(GameEngine *oEngine)
  {
    TSingleMove tLogMove;
    int j;
    char szBuffer[128];

    // and the moves till here
    for (j=MAX_RECURSE_DEBUGLOG-1;j>0;j--)
    {
      tLogMove = aMoveArray[j];
      if (tLogMove.bValidMove)
      {
        oEngine->MoveRepresentation(&tLogMove,szBuffer);
        std::clog << szBuffer << " ";
      }
    }
    std::clog << std::endl;
  }
#endif

//---------------------------------------------------------------------------

AlgorithmRandom::AlgorithmRandom(void)
{
  sName->assign("Random");
}

//---------------------------------------------------------------------------

int AlgorithmRandom::CalcBestMove(GameEngine *oEngine,
                const int nLevel,
                const int nToMove,
                TSingleMove *nBestMoveHere)
{
  TMoveList aMoves;

  oEngine->nNodes++;

  oEngine->GenerateMoves(&aMoves,nToMove);

  if (aMoves.TotalMoves)
  {
    int nIndex = random(aMoves.TotalMoves);
    * nBestMoveHere = aMoves.aMoves[nIndex];
    nBestMoveHere->nScore = -oEngine->EvaluatePos(nToMove);
  }

  return nBestMoveHere->nScore;
}

//---------------------------------------------------------------------------
//eof
