//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#ifdef _DEBUG
#include <iostream>
#include <fstream>
#endif

#include "AlgorithmBase.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------

AlgorithmStaticEval::AlgorithmStaticEval(void)
{
  sName->assign("Static Eval");
}

//---------------------------------------------------------------------------

int AlgorithmStaticEval::CalcBestMove(GameEngine *oEngine,
                const int nLevel,
                const int nToMove,
                TSingleMove *nBestMoveHere)
{
  int nMoves,nActualMove;
  TMoveList aMoves;
  signed int nScore;
  int i;
  TBoard aSavedBoard;

  nMoves = oEngine->GenerateMoves(&aMoves,nToMove);
  if (nMoves)
  {
    for (i=0;i<nMoves;i++)
    {
      oEngine->PushBoard(&aSavedBoard);
      oEngine->ApplyMove(aMoves.aMoves[i],nToMove,1);
      nScore = -oEngine->EvaluatePos(nToMove);
      oEngine->PopBoard(aSavedBoard);
      if (nScore > nBestMoveHere->nScore)
      {
        *nBestMoveHere = aMoves.aMoves[i];
        nBestMoveHere->nScore = nScore;
      }
    }
  }

  return nBestMoveHere->nScore;
}

//---------------------------------------------------------------------------
//eof
